diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8-2.c
index 0dd58ee710e..7e7865d64fe 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8-2.c
@@ -65,16 +65,16 @@ TEST (void)
   CALC(res_ref, src1.a, src2.a);
 
   res1.x = INTRINSIC (_cvtne2ph_pbf8) (src1.x, src2.x);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtne2ph_pbf8) (res2.x, mask, src1.x, src2.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtne2ph_pbf8) (mask, src1.x, src2.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8s-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8s-2.c
index 5e3ea3e37a4..0ca0c420ff7 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8s-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2bf8s-2.c
@@ -65,16 +65,16 @@ TEST (void)
   CALC(res_ref, src1.a, src2.a);
 
   res1.x = INTRINSIC (_cvtnes2ph_pbf8) (src1.x, src2.x);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtnes2ph_pbf8) (res2.x, mask, src1.x, src2.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtnes2ph_pbf8) (mask, src1.x, src2.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8-2.c
index aa928b582b3..97afd395bb5 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8-2.c
@@ -65,16 +65,16 @@ TEST (void)
   CALC(res_ref, src1.a, src2.a);
 
   res1.x = INTRINSIC (_cvtne2ph_phf8) (src1.x, src2.x);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtne2ph_phf8) (res2.x, mask, src1.x, src2.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtne2ph_phf8) (mask, src1.x, src2.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8s-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8s-2.c
index 891fb66e812..2d99d11b023 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8s-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtne2ph2hf8s-2.c
@@ -65,16 +65,16 @@ TEST (void)
   CALC(res_ref, src1.a, src2.a);
 
   res1.x = INTRINSIC (_cvtnes2ph_phf8) (src1.x, src2.x);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtnes2ph_phf8) (res2.x, mask, src1.x, src2.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtnes2ph_phf8) (mask, src1.x, src2.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8-2.c
index 4f83b3a7bb4..d5ba911334c 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8-2.c
@@ -56,16 +56,16 @@ TEST (void)
   CALC(res_ref, src.a);
 
   res1.x = INTRINSIC (_cvtneph_pbf8) (src.x);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtneph_pbf8) (res2.x, mask, src.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtneph_pbf8) (mask, src.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8s-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8s-2.c
index 9e6b44e24de..49e170aa428 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8s-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2bf8s-2.c
@@ -56,16 +56,16 @@ TEST (void)
   CALC(res_ref, src.a);
 
   res1.x = INTRINSIC (_cvtnesph_pbf8) (src.x);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtnesph_pbf8) (res2.x, mask, src.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtnesph_pbf8) (mask, src.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8-2.c
index 41e395daef9..f481b72cc71 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8-2.c
@@ -56,16 +56,16 @@ TEST (void)
   CALC(res_ref, src.a);
 
   res1.x = INTRINSIC (_cvtneph_phf8) (src.x);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtneph_phf8) (res2.x, mask, src.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtneph_phf8) (mask, src.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res3, res_ref))
     abort ();
 }
diff --git a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8s-2.c b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8s-2.c
index 8732bf59bc1..4782b038f3b 100644
--- a/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8s-2.c
+++ b/gcc/testsuite/gcc.target/i386/avx10_2-512-vcvtneph2hf8s-2.c
@@ -56,16 +56,16 @@ TEST (void)
   CALC(res_ref, src.a);
 
   res1.x = INTRINSIC (_cvtnesph_phf8) (src.x);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res1, res_ref))
     abort ();
 
   res2.x = INTRINSIC (_mask_cvtnesph_phf8) (res2.x, mask, src.x);
-  MASK_MERGE (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_MERGE (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res2, res_ref))
     abort ();
 
   res3.x = INTRINSIC (_maskz_cvtnesph_phf8) (mask, src.x);
-  MASK_ZERO (h) (res_ref, mask, SIZE);
-  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res, res_ref))
+  MASK_ZERO (i_b) (res_ref, mask, SIZE);
+  if (UNION_CHECK (AVX512F_LEN_HALF, i_b) (res3, res_ref))
     abort ();
 }